/**
 * Copyright : UJF-VERIMAG 
 * This plug-in is under the terms of the EPL License. 
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * @author Christian Brunette - OpenEmbeDD integration team
 * 
 * 
 *
 * $Id$
 */
package org.ujf.verimag.ARINC.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.ujf.verimag.ARINC.util.ARINCAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers. The adapters generated by this
 * factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}. The adapters
 * also support Eclipse property sheets. Note that most of the adapters are shared among multiple instances. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class ARINCItemProviderAdapterFactory extends ARINCAdapterFactory implements ComposeableAdapterFactory,
		IChangeNotifier, IDisposable
{
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	protected ComposedAdapterFactory	parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	protected IChangeNotifier			changeNotifier	= new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected Collection<Object>		supportedTypes	= new ArrayList<Object>();

	/**
	 * This constructs an instance. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ARINCItemProviderAdapterFactory()
	{
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.ujf.verimag.ARINC.MIF} instances. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected MIFItemProvider	mifItemProvider;

	/**
	 * This creates an adapter for a {@link org.ujf.verimag.ARINC.MIF}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createMIFAdapter()
	{
		if (mifItemProvider == null)
		{
			mifItemProvider = new MIFItemProvider(this);
		}

		return mifItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.ujf.verimag.ARINC.Window} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected WindowItemProvider	windowItemProvider;

	/**
	 * This creates an adapter for a {@link org.ujf.verimag.ARINC.Window}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createWindowAdapter()
	{
		if (windowItemProvider == null)
		{
			windowItemProvider = new WindowItemProvider(this);
		}

		return windowItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.ujf.verimag.ARINC.Partition} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected PartitionItemProvider	partitionItemProvider;

	/**
	 * This creates an adapter for a {@link org.ujf.verimag.ARINC.Partition}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createPartitionAdapter()
	{
		if (partitionItemProvider == null)
		{
			partitionItemProvider = new PartitionItemProvider(this);
		}

		return partitionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.ujf.verimag.ARINC.LogicalComponent} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected LogicalComponentItemProvider	logicalComponentItemProvider;

	/**
	 * This creates an adapter for a {@link org.ujf.verimag.ARINC.LogicalComponent}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createLogicalComponentAdapter()
	{
		if (logicalComponentItemProvider == null)
		{
			logicalComponentItemProvider = new LogicalComponentItemProvider(this);
		}

		return logicalComponentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.ujf.verimag.ARINC.ArincSystem} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ArincSystemItemProvider	arincSystemItemProvider;

	/**
	 * This creates an adapter for a {@link org.ujf.verimag.ARINC.ArincSystem}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createArincSystemAdapter()
	{
		if (arincSystemItemProvider == null)
		{
			arincSystemItemProvider = new ArincSystemItemProvider(this);
		}

		return arincSystemItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.ujf.verimag.ARINC.MajorFrame} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected MajorFrameItemProvider	majorFrameItemProvider;

	/**
	 * This creates an adapter for a {@link org.ujf.verimag.ARINC.MajorFrame}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createMajorFrameAdapter()
	{
		if (majorFrameItemProvider == null)
		{
			majorFrameItemProvider = new MajorFrameItemProvider(this);
		}

		return majorFrameItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.ujf.verimag.ARINC.PeriodicPhysicalComponent}
	 * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected PeriodicPhysicalComponentItemProvider	periodicPhysicalComponentItemProvider;

	/**
	 * This creates an adapter for a {@link org.ujf.verimag.ARINC.PeriodicPhysicalComponent}. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createPeriodicPhysicalComponentAdapter()
	{
		if (periodicPhysicalComponentItemProvider == null)
		{
			periodicPhysicalComponentItemProvider = new PeriodicPhysicalComponentItemProvider(this);
		}

		return periodicPhysicalComponentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.ujf.verimag.ARINC.Task} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected TaskItemProvider	taskItemProvider;

	/**
	 * This creates an adapter for a {@link org.ujf.verimag.ARINC.Task}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createTaskAdapter()
	{
		if (taskItemProvider == null)
		{
			taskItemProvider = new TaskItemProvider(this);
		}

		return taskItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.ujf.verimag.ARINC.AperiodicPhysicalComponent}
	 * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected AperiodicPhysicalComponentItemProvider	aperiodicPhysicalComponentItemProvider;

	/**
	 * This creates an adapter for a {@link org.ujf.verimag.ARINC.AperiodicPhysicalComponent}. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createAperiodicPhysicalComponentAdapter()
	{
		if (aperiodicPhysicalComponentItemProvider == null)
		{
			aperiodicPhysicalComponentItemProvider = new AperiodicPhysicalComponentItemProvider(this);
		}

		return aperiodicPhysicalComponentItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory()
	{
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory)
	{
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type)
	{
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type)
	{
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type)
	{
		if (isFactoryForType(type))
		{
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class) || (((Class<?>) type).isInstance(adapter)))
			{
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener)
	{
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener)
	{
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification)
	{
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null)
		{
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void dispose()
	{
		if (mifItemProvider != null)
			mifItemProvider.dispose();
		if (windowItemProvider != null)
			windowItemProvider.dispose();
		if (partitionItemProvider != null)
			partitionItemProvider.dispose();
		if (logicalComponentItemProvider != null)
			logicalComponentItemProvider.dispose();
		if (arincSystemItemProvider != null)
			arincSystemItemProvider.dispose();
		if (majorFrameItemProvider != null)
			majorFrameItemProvider.dispose();
		if (periodicPhysicalComponentItemProvider != null)
			periodicPhysicalComponentItemProvider.dispose();
		if (taskItemProvider != null)
			taskItemProvider.dispose();
		if (aperiodicPhysicalComponentItemProvider != null)
			aperiodicPhysicalComponentItemProvider.dispose();
	}

}
